## 一.普通字符常量
1.	一个字符 用 单引号 **''** 括起来

## 二.转义字符常量
1.	常见的转义字符
	|  字符  |  含义  |
	| ---- | ---- |
	|  ‘\n’  | *Line Feed (LF)* 换行, 光标往下移动一格	|
	|  ‘\r’	| *Carriage Return (CR)* 回车，回到本行开头 |
	|  ‘\”’	|双引号|
	|  ‘\’’  |单引号|
	|  ‘\\\\’  |斜线|
	|  ‘\0’	|空字符，字符串结尾	|
	|  ‘\a’	|响铃提示音|
	|  ‘\t’	|水平制表	|
	|  ‘\v’	|垂直制表	|
	|  ‘\\?’  |问号|
	|  ‘\b’	|退格	|
	|  ‘\f’  |走纸换页。按照当前打印机的设置跳过一页纸，换到下页。	|
	|  ‘\ddd’  |表示三位八进制ascii码所表示的值。无前导符0。	|
	|  ‘\xhh’|  表示两位十六进制ascii码所表示的值。无前导符0。|
	>UNIX/Linux系统一般采用'\n'表示换行，Windows系统一般采用‘\r\n’表示换行，MAC OS系统一般采用'\r'表示换行。
	>在windows中当我们在程序中打开文本文件时，从文件中读到\r\n时流会转换为\n，而往文件中写入\n时流会转换为\r\n。
2.	常见字符的ASCII码
	|  ASCII（十进制）|含义|
	| ---- | ---- |
	|  0  |  '\0',字符串结尾  |
	|  10  | '\n'  |
	|  13  | '\r'  |
	|  32  |空格  |
	|  48 - 57 | '0'-'9'  |
	|  65 - 90 | 'A'-'Z'  |
	|  97 - 122 | 'a'-'z'  |

## 三.字符串常量
1.	由一个及以上字符组成 用 双引号**""**括起来。
2.	字符串常量本身也可代表其地址（实际上是字符数组到指针的转换）。字符串常量是左值，可以取地址。
```c++
const char* a = “hello world”; //OK
cout<<&"Hi"; //OK
```
3.	字符串常量的大小为所有字符长度(strlen)加1。

## 四.符号常量(宏常量)
详见 从C到C++ ->预处理命令 -> 宏定义