## 一.整型常量
1.	默认情况下，整型常量为有符号常量。
	
	>[success]30,-10,25
2.	整型常量支持以十进制、八进制(0前缀)、十六进制(0x前缀)数字表示。不支持二进制表示。
	>[success]024,0xae
	
	+	**注意** 八进制的常量没有8和9
		
		>[danger][错例]02019
	
3.	L(l)后缀表示长整型常量,U(u)后缀表示无符号常量。
	>[success]2020l,2020U,2020lu,2020uL

	+	**注意** 无符号常量不能带负号
## 二.实型常量
1.	实型常量有 **小数** 和 **指数** 两种表示形式。实型常量只支持十进制。
    
	+ **xey** *表示x乘以10的y次方*
	  	+	x可为小数，y**只能是整数**。
		+	x、y不可省。

      >[success][正确]1.2e-9
	
	  >[danger][错误]-1.23e-1.02
	
	  +	以小数形式表示时，若整数部分为0，则整数部分可缺省。
	
	>[success].123
2.	float型变量一般仅能接受7位 **有效数字** 的实型常量。double型量一般可以接受16位 **有效数字** 的实型常量。
3.	默认情况下，实型常量为双精度型常量。
4.	后缀F(f)表示单精度常量。后缀L(l)表示长型常量。
5.	不能直接比较两个浮点数的大小。浮点数并非真正意义上的实数，因此只能用近似的方法进行比较。当有效数字较多时直接比较往往就会出现问题。
	+	正确的比较方式：设置一个近似0(如 1e-6)，
		+	当fabs(a-b) <= 近似0 可认为a = b
		+	当a-b > 近似0 可认为a > b
		+	当a-b < 近似0 可认为a < b

## 三.枚举型常量
1.	**定义一个枚举类型** enum i {a,b,c,d}，其中a,b,c,d为常量。
2.	判断各常量的值
	+	若不指定值，则默认第一个值为0，第二个值为1，第三个值为2，以此类推。
	+	从指定值的位置开始，后面的值依次递增1。
	>[info]若有定义 enum test {a=10,b,c=3,d};
	>则a=10,b=11,c=3,d=4.

