>[danger] 需要引入 `cstdio` 或 `stdio.h`

## 一.单个字符的输入

| 	**函数** | **int** getchar()                                            |
| -------- | ------------------------------------------------------------ |
| 	**功能** | 从标准输入 (stdin)中读取一个字符。若输入缓冲区中没有字符，则从系统隐含指定的输入设备(键盘)中输入一个字符。**若输入缓冲区中有字符，则不会从系统隐含指定的输入设备(键盘)中输入一个字符，而是从缓冲区中读取字符。** |
| 	**参数** | 没有参数                                                     |
| 	**返回** | **int**   以无符号 char 强制转换为 int 的形式返回读取的字符，如果到达文件末尾或发生读错误，则返回 EOF。 |

```c++
/*清理输入缓冲区，如果缓冲区为空会要求控制台读取字符*/
void CleanStdin()
{
	char ch;
	do {
			ch = getchar();
	} while( ch!= '\n');/*清理输入缓冲区*/
}
```

## 二.单个字符的输出

| 	**函数**       | **int** putchar( **int**  char)                                           |
| 	---------- | ------------------------------------------------------------ |
| 	**功能**   | 把参数 char 指定的字符（一个无符号字符）写入到标准输出(stdout)中。 |
| 	**参数**   | **int** char   要输出的字符。                                |
| 	**返回值** | **int**  该函数以无符号 char 强制转换为 int 的形式返回写入的字符，如果发生错误则返回 EOF。 |

