>[danger] 该对象位于头文件 `deque`

## [$]一.概述
1.	**概念** 双端队列(double-ended queue)是一个有下标顺序的，可以在首末两段快速插入删除的顺序容器。
2.	**存储结构** 它的元素被分散在不同的数组中，通过指针数组连接。

## [$]二.双端队列的初始化
```c++
//1.定义一个已知长度的deque，在内部会初始化为0
deque<int> score(20);

//2.定义一个已知长度的deque并初始化为60
deque<int> score(20,60);

//4.用另一个deque初始化该vector;
deque<int> score(20,60);
deque<int> grade(score);
```
## [$]三.访问双端队列内的元素
1.	随机访问元素
	|  操作| 作为左值 | 越界检查 | 例子 |
	|  ---- |  ----|  ----|  ---- |
	|  下标访问|  √|不进行|`score[1]`|
	|  `at` 方法访问|  √|进行,越界时抛出一个 `std::out_of_range` 的异常|`score.at(1)`|

	+	访问范围 `[0,vector_obj.size())`
2.	访问特定元素
	|  操作| 作为左值 | 描述 |
	|  ----|  ----|  ----|
	|   `obj.front()` |  √|  返回第一个元素|
	|  `obj.back()` |  √|  返回最后一个元素|

## [$]四.双端队列的增删
|  操作| 描述 |
|  ----|  ----|
|   `void obj.push_back(val)` |  向末尾添加一个元素|
|   `void obj.pop_back(val)` |  删除末尾元素|
|   `void obj.push_front(val)` |  向首个元素前面添加一个元素|
|   `void obj.pop_front(val)` |  删除收个元素|

