>[danger] 该对象位于头文件 `vector`

## [$]一.概述
1.	**概念** 向量(Vector)是一个封装动态数组的顺序容器。
2.	它可以自动管理内存，按照需要扩张收缩，但通常占用多余数组的空间，因为要分配更多内存以管理将来的增长。
3.	**存储结构** 动态数组

## [$]二.向量的初始化
```c++
//1.定义一个已知长度的向量，在内部会初始化为0
vector<int> score(20);

//2.定义一个已知长度的向量并初始化为60
vector<int> score(20,60);

//3.用数组定义一个向量
int origin[6] = {1,2,3,4,5,6};
vector<int> score(origin,origin+6);
//第一个参数为数组首地址，第二个参数为数组最后一个元素地址的下一个地址

//4.用另一个vector初始化该vector;
vector<int> score(20,60);
vector<int> grade(score);
```
## [$]三.访问向量内的元素
1.	随机访问元素
	|  操作| 作为左值 | 越界检查 | 例子 |
	|  ---- |  ----|  ----|  ---- |
	|  下标访问|  √|不进行|`score[1]`|
	|  `at` 方法访问|  √|进行,越界时抛出一个 `std::out_of_range` 的异常|`score.at(1)`|

	+	访问范围 `[0,vector_obj.size())`
2.	访问特定元素
	|  操作| 作为左值 | 描述 |
	|  ----|  ----|  ----|
	|   `obj.front()` |  √|  返回第一个元素|
	|  `obj.back()` |  √|  返回最后一个元素|

## [$]四.向量的增删
|  操作| 描述 |
|  ----|  ----|
|   `void obj.push_back(val)` |  向末尾添加一个元素|
|   `void obj.pop_back(val)` |  删除末尾元素|
