## 一.while语句

1. 	语法格式
```c++
while ( condition ) 
	statement
```
2.	进行流程
	1.	执行 `condition` 如果结果为 `false` 则退出循环。
	2.	执行 `statement`  。
	3.	重复 1 - 2 步骤。

## 二.do while语句
1. 	语法格式
	
	>[warning] 注意语句末尾有分号
```c++
do 
	statement 
while ( condition );
```
2.	进行流程
	1.	执行 `statement`  。
	2.	执行 `condition` 如果结果为 `false` 则退出循环。
	3.	重复 1 - 2 步骤。

## 三.for语句
1.	语法格式
	>[warning]每个语句之间用分号隔开，且不可省略
	
	+	init-statement 初始化语句，可以是声明语句或表达式。
	+	condition 条件语句，用作循环控制。当条件为 `true` 时继续循环，否则退出循环。省略时表示其为 `true` .
	+	expression 表达式，在循环每次迭代后被计算
```c++
for ( init-statement; condition; expression ) 
	statement;
```

2.	进行流程
	1.	执行 `init-statement` 。
	2.	执行 `condition` 如果结果为 `false` 则退出循环。
	3.	执行 `statement`  。
	4.	执行 `expression` 。
	5.	重复2 - 4步骤。

## \[11+\][$]四.范围for语句：遍历容器内的元素
1.	语法格式
	+	`declaration` 定义/声明语句，若需要修改序列中的元素，则需要声明成引用。
	+	`expression` 表示一个序列，比如花括号括起来的初始值列表，或者数组等可以通过迭代器访问的对象。
```c++
for ( declaration : expression ) 
	statement;
```
2.	本质：通过迭代器逐个访问容器内的元素
```c++
/*对所有数进行平方*/
vector<int> num_list = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
for (auto &num : num_list) /*平方*/
    num *= num;
for (auto num : num_list) /*输出*/
    cout << num << " ";
return 0;
```
>[test]
>1 4 9 16 25 36 49 64 81 100 

+	若改成普通的for语句

```c++
vector<int> num_list = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
for (vector<int>::iterator begin = num_list.begin(), end = num_list.end(); begin < end; begin++)
{
    int &num = *begin;
    num *= num;
 }
for (vector<int>::iterator begin = num_list.begin(), end = num_list.end(); begin < end; begin++)
{
    int num = *begin;
    cout << num << " ";
}
```

